#include "common.ch"

MEMVAR _REQUEST

FUNCTION HRBMAIN()

LOCAL i , cTemp  , cRes := '' 

	SET DATE FORMAT "yyyy-mm-dd"

	cTable		:= _REQUEST[ "cDbf" ]
	cForExpr	:= _REQUEST[ "cForExpr" ]
	cOrder		:= _REQUEST[ "cOrder" ]

	cUser		:= _REQUEST[ "cUser" ]
	cPassword	:= _REQUEST[ "cPassword" ]

	* CHECK VALID USER ************************************************

	IF EMPTY(cUser) .OR. EMPTY(cPassword)
		RETURN 'ERROR: INVALID ACCOUNT!'
	ENDIF
	USE ../DATA/USERS SHARED
	LOCATE FOR ALLTRIM(UPPER(USER)) == ALLTRIM(UPPER( cUser )) ;
		.AND. ;
		ALLTRIM(UPPER(PASSWORD)) == ALLTRIM(UPPER( cPassword )) 
		IF .NOT. FOUND()
			USE
			RETURN 'ERROR: INVALID ACCOUNT!'
		ENDIF			
	USE

	* END CHECK VALID USER ********************************************

	* VALID FILE NAME *************************************************
	
	IF AT('\',cTable) <> 0 .OR. AT('/',cTable) <> 0
		RETURN 'ERROR (BROWSE): INVALID FILE NAME'
	ENDIF

	* END VALID FILE NAME *********************************************


	USE ( '../DATA/' + cTable ) INDEX ( '../DATA/' + cTable ) SHARED

		SET ORDER TO TAG ( cOrder)

		GO TOP

		IF .NOT. EMPTY(cForExpr)
			SET FILTER TO &cForExpr
			GO TOP
			COUNT TO nRecCount
		ELSE
			nRecCount := OrdKeyCount()
		ENDIF

	USE 

return ALLTRIM(STR(nRecCount))

//---------------------------------------------------------------------------------------------
function AnyToC ( xAnswer )
//---------------------------------------------------------------------------------------------

	IF	VALTYPE ( xAnswer ) = 'C'
		cAnswer := xAnswer
	ELSEIF	VALTYPE ( xAnswer ) = 'N'
		cAnswer := STR(xAnswer)
	ELSEIF	VALTYPE ( xAnswer ) = 'D'
		cAnswer := DTOC(xAnswer)
	ELSEIF	VALTYPE ( xAnswer ) = 'L'
		cAnswer := IF(xAnswer,'Yes','No')
	ELSEIF	VALTYPE ( xAnswer ) = 'A'
		cAnswer := 'ARRAY!'
	ELSEIF	VALTYPE ( xAnswer ) = 'B'
		cAnswer := 'BLOCK!'
	ELSEIF	VALTYPE ( xAnswer ) = 'M'
		cAnswer := 'MEMO!'
	ELSEIF	VALTYPE ( xAnswer ) = 'O'
		cAnswer := 'OBJECT!'
	ELSEIF	VALTYPE ( xAnswer ) = 'U'
		cAnswer := 'NIL'
	ELSE
		cAnswer := 'RARE TYPE! (This is not happening!)'
	ENDIF

return cAnswer

*------------------------------------------------------------------------------*
FUNCTION Random( nLimit )
*------------------------------------------------------------------------------*
  Static snRandom := Nil
  Local nDecimals, cLimit

  DEFAULT snRandom TO Seconds() / Exp(1)
  DEFAULT nLimit   TO 65535

  snRandom  := Log( snRandom + Sqrt(2) ) * Exp(3)
  snRandom  := Val( Str(snRandom - Int(snRandom), 17, 15 ) )
  cLimit    := Transform( nLimit, "@N" )

  nDecimals := At(".", cLimit)

  if nDecimals > 0
     nDecimals := Len(cLimit)-nDecimals
  endif

Return Round( nLimit * snRandom, nDecimals )
